<template>
  <div class="map">
    <button type="buton" class="map-reload" @click="reloadMap">
      <svg width="24" height="24" fill="none" xmlns="http://www.w3.org/2000/svg"><path d="M23 12c0 6.075-4.924 11-11 11S1 18.075 1 12 5.924 1 12 1s11 4.925 11 11z" stroke="#fff" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/><path d="M15.535 8.464a5 5 0 010 7.072m-7.07 0a5 5 0 010-7.072" stroke="#fff" stroke-width="2" stroke-linecap="round" stroke-linejoin="round"/><path fill-rule="evenodd" clip-rule="evenodd" d="M10.613 9.666a.5.5 0 01-.86.248L7.178 7.11a.5.5 0 01.318-.836l3.15-.317a.5.5 0 01.541.588l-.574 3.121zM13.445 14.375a.5.5 0 01.86-.25l2.585 2.805a.5.5 0 01-.316.836l-3.155.325a.5.5 0 01-.543-.587l.57-3.129z" fill="#fff"/></svg>
    </button>
    <div :id="mapId" />
    <div class="no-tracking" v-if="!isTracking">
      <div class="no-tracking__content">
        <p>
          Нет подключенных устройств трекинга
        </p>
        <ob-button label="Подключить"></ob-button>
      </div>
    </div>
    <div class="no-tracking" v-if="waiting">
      <div class="no-tracking__content">
        <p>
          Ожидание начала трекинга
          </p>
      </div>
    </div>
    <!-- <l-map
      :zoom="zoom"
      :center="center"
      :options="mapOptions"
      style="height: 100%"
    >
      <l-tile-layer
        :url="url"
        :attribution="attribution"
      />
    </l-map> -->
  </div>
</template>

<script>
  import api from '@/api';
  import L from 'leaflet'
  import 'leaflet.tilelayer.colorfilter';
  import'leaflet-routing-machine';
  import 'leaflet.fullscreen';
  import 'leaflet-edgebuffer/src/leaflet.edgebuffer';
  import '@ansur/leaflet-pulse-icon/dist/L.Icon.Pulse.js';
  import '@ansur/leaflet-pulse-icon/dist/L.Icon.Pulse.css';

  import ObButton from 'common-components/src/obComponents/obButton';

  import { Icon } from "leaflet";
  // import { LMap, LTileLayer, LMarker } from 'vue2-leaflet';
  
  delete Icon.Default.prototype._getIconUrl;
    Icon.Default.mergeOptions({
    iconRetinaUrl: require('leaflet/dist/images/marker-icon-2x.png'),
    iconUrl: require('leaflet/dist/images/marker-icon.png'),
    shadowUrl: require('leaflet/dist/images/marker-shadow.png'),
  });

  const _setPosOriginal = L.Marker.prototype._setPos

  L.Marker.include({
    _setPos: function(pos) {
      _setPosOriginal.call(this, pos)
      if (this.options.rotation) this._rotate()
    },
    _rotate: function() {
      this._icon.style[`${L.DomUtil.TRANSFORM}Origin`] = this.options.rotationOrigin
      this._icon.style[L.DomUtil.TRANSFORM] += ` rotate(${this.options.rotation}deg)`
    }
  })

  export default {
    name: 'trackingOrderMap',

    components: {
      // LMap,
      // LTileLayer,
      // LMarker,
      ObButton
    },

    props: {
      trackData: {
        type: Object,
        default: () => null
      }
    },

    data() {
      return {
        mymap: '',
        mapId: '333',
        markers: [],
        waiting: false
      }
    },

    computed: {
      isTracking() {
        return true;
      }
    },

    mounted() {
      this.initMap();
    },

    methods: {
      async initMap() {
        const res = this.trackData || await api.orders.fetchTrack(this.$route.params.id);
        if (!res.actualTrack.currentPoint && !res.actualTrack.trackPoints) {
          await this.initEmptyMap(res);
          // this.waiting = true;
          return false;
        }

        const loadingPoints = res.points.filter(point => point.pointType === 'loading');

        const unloadingPoints = res.points.filter(point => point.pointType === 'unloading');

        const fromPoint = res.points.find(point => point.ordinal === 1);

        const points = res.planTrack.trackPoints.reduce((acc, point) => {
          acc.push([point.lat, point.lon]);
          return acc;
        }, []);

        const trackPoints = res.actualTrack.trackPoints.reduce((acc, point) => {
          acc.push([point.lat, point.lon]);
          return acc;
        }, []);

        const pointsToStart = res.planTrack.pointsBeforeStartPoint.reduce((acc, point) => {
          acc.push([point.lat, point.lon]);
          return acc;
        }, []);

        const currentPoint = (res.actualTrack.currentPoint.lat && res.actualTrack.currentPoint.lon)
            ? res.actualTrack.currentPoint
            : res.actualTrack.trackPoints[res.actualTrack.trackPoints.length - 1];

        const beforeCurrentPoint = res.actualTrack.trackPoints[res.actualTrack.trackPoints.length - 2]
            ? res.actualTrack.trackPoints[res.actualTrack.trackPoints.length - 2]
            : {
                lat: fromPoint.lat,
                lon: fromPoint.lon
              };

        let myFilter = ['grayscale:90%', 'invert:90%', 'opacity:90%'];

        this.mymap = L.map(this.mapId, { zoomControl: true, fullscreenControl: true })

        L.tileLayer
            .colorFilter(
                'https://maps.googleapis.com/maps/vt?language=ru-RU&pb=!1m5!1m4!1i{z}!2i{x}!3i{y}!4i256!2m3!1e0!2sm!3i349018013!3m9!2sen-US!3sUS!5e18!12m1!1e47!12m3!1e37!2m1!1ssmartmaps!4e0',
                {
                  filter: myFilter,
                  attribution: '',
                  edgeBufferTiles: 5
                }
            )
            .addTo(this.mymap);

        loadingPoints.forEach((fromPoint) => {
          L.marker(
              [fromPoint.coordinate.lat, fromPoint.coordinate.lon],
              {
                title: 'Погрузка',
                icon: L.icon({
                  iconUrl: fromPoint.dateTime ? require('../../../assets/images/mapIconLoadingActive.svg') : require('../../../assets/images/mapIconLoading.svg'),
                  iconSize: [30, 62],
                  iconAnchor: [15, 56]
                })
              }
          ).addTo(this.mymap)
        })

        unloadingPoints.forEach((toPoint) => {
          L.marker(
              [toPoint.coordinate.lat, toPoint.coordinate.lon],
              {
                title: 'Разгрузка',
                icon: L.icon({
                  iconUrl: toPoint.dateTime ? require('../../../assets/images/mapIconToActive.svg') : require('../../../assets/images/mapIconTo.svg'),
                  iconSize: [30, 62],
                  iconAnchor: [15, 56]
                })
              }
          ).addTo(this.mymap)
        })

        if (res.actualTrack.startTrackPoint) {
          L.marker(
              [res.actualTrack.startTrackPoint.lat, res.actualTrack.startTrackPoint.lon],
              {
                title: 'Старт трекинга',
                icon: L.icon({
                  iconUrl: require('../../../assets/images/startTrack.svg'),
                  iconSize: [30, 62],
                  iconAnchor: [15, 65]
                })
              }
          ).addTo(this.mymap)
        }

        L.marker(
            [currentPoint.lat, currentPoint.lon],
            {
              rotation: this.angleCrds(this.mymap, L.latLng(beforeCurrentPoint.lat, beforeCurrentPoint.lon), L.latLng(currentPoint.lat, currentPoint.lon)),
              title: 'Текущее положение ТС',
              icon: L.icon({
                iconUrl: require('../../../assets/images/tracking-map-1.svg'),
                iconSize: [30, 30],
                iconAnchor: [15, 15]
              })
            }
        ).addTo(this.mymap)

        if (res.actualTrack.currentPoint.lat && res.actualTrack.currentPoint.lon && res.actualTrack.trackPoints.length) {
          if (res.actualTrack.currentPoint.lat === res.actualTrack.trackPoints[0].lat
              && res.actualTrack.currentPoint.lon === res.actualTrack.trackPoints[0].lon) {
            L.marker(
                [currentPoint.lat, currentPoint.lon],
                {
                  title: 'ТС находится в точке погрузки',
                  icon: L.icon({
                    iconUrl: require('../../../assets/images/tracking-map-in-loading.svg'),
                    iconSize: [30, 62],
                    iconAnchor: [15, 56]
                  })
                }
            ).addTo(this.mymap)
          }

          if (res.actualTrack.currentPoint.lat === res.actualTrack.trackPoints[res.actualTrack.trackPoints.length - 1].lat
              && res.actualTrack.currentPoint.lon === res.actualTrack.trackPoints[res.actualTrack.trackPoints.length - 1].lon) {
            L.marker(
                [currentPoint.lat, currentPoint.lon],
                {
                  title: 'ТС находится в точке разгрузки',
                  icon: L.icon({
                    iconUrl: require('../../../assets/images/tracking-map-in-unloading.svg'),
                    iconSize: [30, 62],
                    iconAnchor: [15, 56]
                  })
                }
            ).addTo(this.mymap)
          }
        }


        // L.Routing.control({
        //   waypoints: [
        //     L.latLng(55.755814, 37.617635),
        //     L.latLng(59.939095, 30.315868)
        //   ],
        //   lineOptions: {
        //     styles: [
        //       {color: '#003953', weight: 6},
        //       {color: '#131C25', weight: 2}
        //     ]
        //   },
        //   routeWhileDragging: false,
        //   createMarker: function() { return null; }
        // }).addTo(this.mymap);
        // var latlngs = [
        //     [45.51, -122.68],
        //     [37.77, -122.43],
        //     [34.04, -118.2]
        // ];
        const polyline = L.polyline(points, {color: '#006596', weight: 6}).addTo(this.mymap);
        L.polyline(trackPoints, {color: '#00DDB4', weight: 4}).addTo(this.mymap);
        L.polyline(pointsToStart, {color: '#737682', weight: 3}).addTo(this.mymap);
        this.mymap.fitBounds(polyline.getBounds());

        // const group = L.featureGroup(this.markers).addTo(this.mymap);
        // this.mymap.fitBounds(group.getBounds());
      },

      async initEmptyMap(res) {
        const loadingPoints = res.points.filter(point => point.pointType === 'loading');

        const unloadingPoints = res.points.filter(point => point.pointType === 'unloading');

        const points = res.planTrack.trackPoints.reduce((acc, point) => {
          acc.push([point.lat, point.lon]);
          return acc;
        }, []);

        let myFilter = ['grayscale:90%', 'invert:90%', 'opacity:90%'];
        
        this.mymap = L.map(this.mapId, { zoomControl: true, fullscreenControl: true });
        
        L.tileLayer
          .colorFilter(
            'https://maps.googleapis.com/maps/vt?language=ru-RU&pb=!1m5!1m4!1i{z}!2i{x}!3i{y}!4i256!2m3!1e0!2sm!3i349018013!3m9!2sen-US!3sUS!5e18!12m1!1e47!12m3!1e37!2m1!1ssmartmaps!4e0',
            {
              filter: myFilter,
              attribution: '',
              edgeBufferTiles: 5
            }
          )
          .addTo(this.mymap);

        this.markers = [
          loadingPoints.forEach((fromPoint) => {
            L.marker(
              [fromPoint.coordinate.lat, fromPoint.coordinate.lon],
              {
                title: 'Погрузка',
                icon: L.icon({
                  iconUrl: fromPoint.dateTime ?  require('../../../assets/images/mapIconLoadingActive.svg') : require('../../../assets/images/mapIconLoading.svg'),
                  iconSize: [30, 62],
                  iconAnchor: [15, 56]
                })
              }
            ).addTo(this.mymap)
          }),

          unloadingPoints.forEach((toPoint) => {
            L.marker(
              [toPoint.coordinate.lat, toPoint.coordinate.lon],
              {
                title: 'Разгрузка',
                icon: L.icon({
                  iconUrl: toPoint.dateTime ? require('../../../assets/images/mapIconToActive.svg') : require('../../../assets/images/mapIconTo.svg'),
                  iconSize: [30, 62],
                  iconAnchor: [15, 56]
                })
              }
            ).addTo(this.mymap)
          }),
        ]

        const polyline = L.polyline(points, {color: '#006596', weight: 6}).addTo(this.mymap);
        this.mymap.fitBounds(polyline.getBounds());
      },

      angleCrds (map, prevLatlng, latlng) {
        if (!latlng || !prevLatlng) return 0;
        const pxStart = map.project(prevLatlng);
        const pxEnd = map.project(latlng);
        return Math.atan2(pxStart.y - pxEnd.y, pxStart.x - pxEnd.x) / Math.PI * 180 - 90;
      },

      reloadMap() {
        this.mymap.remove();
        this.initMap();
      }
    }
  }
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

.map {
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  display: flex;
  flex-direction: column;
  align-items: center;

  &::v-deep {
    .leaflet-control-container {
      position: absolute;
      right: 20px;
      top: 50%;
      margin-top: -34px;
      width: 24px;
      height: 68px;
    }

    .leaflet-left .leaflet-control {
      margin-left: 0;
    }

    .leaflet-top .leaflet-control {
      margin-top: 0;
    }

    .leaflet-control-zoom.leaflet-bar {
      box-shadow: none;
    }

    .leaflet-control-zoom-in, .leaflet-control-zoom-out {
      width: 24px;
      height: 24px;
      margin-bottom: 20px;
      border-radius: 50% !important;
      border: 2px solid #fff;
      background-color: transparent;
      color: #fff;
      display: flex;
      justify-content: center;
      align-items: flex-end;
      line-height: 1;
    }

    .leaflet-control-zoom-fullscreen {
      background-color: transparent;
      position: relative;

      &:after {
        content: '';
        width: 24px;
        height: 24px;
        position: absolute;
        top: 0;
        left: 0;
        background-image: url('../../../assets/images/fullscreen.svg');
        background-size: contain;
        background-repeat: no-repeat;
      }
    }

    .leaflet-control-attribution, .leaflet-routing-alternatives-container {
      display: none;
    }

    img {
      transform-origin: center;
    }
  }
}

.map-reload {
  appearance: none;
  display: flex;
  justify-content: center;
  align-items: center;
  position: absolute;
  width: 24px;
  height: 24px;
  top: 20px;
  right: 20px;
  border: none;
  background-color: transparent;
  z-index: 2;
  cursor: pointer;
  outline: none;
}

.leaflet-container {
  flex-grow: 1;
  width: 100%;
  z-index: 1;
}

.leaflet-top {
  top: 50%;
  margin-top: -30px;
}

.no-tracking {
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  z-index: 3;
}

.no-tracking__content {
  padding: 0 10px;
  width: 212px;
  height: 171px;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  background-color: rgba(0, 0, 0, 0.8);
  border-radius: 3px;
  @include font-mixin(14px, 18px, 400, $cssForm_el_switch_core_background_color_after);
  text-align: center;

  p {
    margin-bottom: 30px;
  }
}
</style>